#include "algoritmus.h"

int **vytvor_pole(int riadky, int stlpce) {
    int **p_p_x, i, j;
    p_p_x = (int **) malloc(riadky * sizeof(int *));
	for (i = 0; i < riadky; i++) {
		p_p_x[i] = (int *) malloc(stlpce * sizeof(int));
	}
	for (i = 0; i < riadky; i++) {
        for (j = 0; j < stlpce; j++) {
            p_p_x[i][j] = -1;
        }
	}
	return(p_p_x);
}

void uvolni_pole(int **p_p_x, int riadky) {
	int i;
	for (i = 0; i < riadky; i++) {
		free((void *) p_p_x[i]);
	}
	free((void *) p_p_x);
}

void vyhodnot(int h[]) {
    char hodnotenie[4];
    putchar('\n');
    scanf(" %3[^\n]s", hodnotenie);
    h[0] = (int)hodnotenie[0] - 48; // nok
    h[1] = (int)hodnotenie[2] - 48; // ok
}

void vypis(int komb[], int m) {
    int i;
    for (i = 0; i < m; i++) {
        printf("%d ", komb[i]);
    }
}

void zisti_cisla(int **g, int m, int f) {
    int i, j, k, l = 0, spolu = 0, h[2], prv[m];
    for (i = 0; i < f; i++) {
        for (j = 0; j < m; j++) {
            printf("%d ", i);
        }
        vyhodnot(h);
        spolu += h[1];
        if (h[1] == m) {
            KONIEC
    printf("\n\nF I N I T O !\n");
            getchar();
            exit(0);    }
        if (h[1] > 0) {
            for (k = 0; k < h[1]; k++) {
                prv[l] = i;
                l++;
                if (l == m) {
                    break;
                }
            }
        }
        if (spolu == m) // ak je v kombinacii viac rovnakych cisiel, vyskoci z cyklu skor
            break;
    }
    // kontrola docasnych vyhodnoteni
    if (spolu != m) {
        printf("\nNiektore vyhodnotenie bolo nespravne! Znova od zaciatku!\n\n");
        zisti_cisla(g, m, f);
    }
    vypis(prv, m);
    for (i = 0; i < m; i++) {
        g[0][i] = prv[i]; // prva kombinacia do pola
    }
    vyhodnot(h);
    if (h[0] + h[1] != m) {
        printf("\nPosledne vyhodnotenie bolo nespravne! Znova od zaciatku!\n\n");
        zisti_cisla(g, m, f);
    }
    dorovnaj(g, prv, h, m, f);
}

void prehod_dve_cisla(int komb[], int m, int a, int b) {
    // ochrana proti preteceniu
    a = a > m - 1 ? 0 : a;
    b = b > m - 1 ? 0 : b;
    b = a == b ? a + 1 : b;
    // aby sa neprehadzovali rovnake hodnoty
    while(komb[a] == komb[b]) {
        a++;
        b++;
        a = a > m - 1 ? 0 : a;
        b = b > m - 1 ? 0 : b;
    }
    int c = komb[a];
    komb[a] = komb[b];
    komb[b] = c;
}

void dorovnaj(int **g, int prv[], int h[], int m, int f) {
    int i, por = 1, a = 0, b = 1, dru[m], pom = h[1];
    while (h[1] < m) {
        // prvotnu kombinaciu ulozime do pracovnej
        for (i = 0; i < m; i++) {
            dru[i] = prv[i];
        }
        prehod_dve_cisla(dru, m, a, b);
        // kontrola aby sa viac krat nepouzila rovnaka kombinacia
        if (pouzite(g, dru, m, por)) {
            b++;
        }
        else {
            for (i = 0; i < m; i++) {
                g[por][i] = dru[i]; // ulozenie kombinacie do pola
            }
            vypis(dru, m);
            vyhodnot(h);
            if(h[1] > pom) {
                for (i = 0; i < m; i++) {
                    prv[i] = dru[i]; //  ak je nove hodnotenie lepsie, uloz kombinaciu ako prvotnu
                }
                pom = h[1];
            }
            if (h[0] + h[1] != m) {
                printf("\nPosledne vyhodnotenie bolo nespravne! Znova od zaciatku!\n\n");
                zisti_cisla(g, m, f);
            }
            por++;
        }
        a++;
    }
    KONIEC

}

bool pouzite(int **g, int prv[], int m, int por) {
    bool uz_bolo = false;
    int i, j, k;
    for (i = 0; i < por; i++) {
        k = 0;
        for (j = 0; j < m; j++) {
            if (prv[j] == g[i][j]) {
                k++;
            }
        }
        if (k == m) {
            uz_bolo = true;
            break;
        }
    }
    return uz_bolo;
}
